class Button
{
  int xPos, yPos;
  int bWidth, bHeight;
  boolean over;
  boolean isInteractive;
  String name;
  PFont fontButton = createFont("Showcard Gothic", 20);
  color clickedColor = color(111, 177, 255);

  Button (String name, int xPos, int yPos, int bWidth, int bHeight, boolean isInteractive) {
    this.name = name;
    this.xPos = xPos;
    this.yPos = yPos;
    this.bWidth = bWidth;
    this.bHeight = bHeight;
    this.isInteractive = isInteractive;
  }
  
  void display() {
    textAlign(CENTER);
    textFont(fontButton);
    if(over && isInteractive) {
      stroke(225, 228, 242);
    }
    else {
      stroke(111, 177, 255);
    }
    fill(5);
    rect(xPos, yPos, bWidth, bHeight);
    if(over && isInteractive) {
      fill(225, 228, 242);
    }
    else {
      fill(111, 177, 255);
    }
    text(name, (xPos) + bWidth / 2, (yPos) + 2 * bHeight / 3);
  }
  
  void update() {
    if(over()) {
      over = true;
    } else {
      over = false;
    }
  }
  
  boolean over() {
    if(mouseX > xPos && mouseX < xPos+bWidth &&
    mouseY > yPos && mouseY < yPos+bHeight) {
      return true;
    } else {
      return false;
    }
  }
}
